﻿using System;
using System.Collections.Generic;
using System.Globalization;
using System.Linq;
using System.Net;
using System.Net.Http;
using System.Net.Http.Headers;
using System.Text;
using System.Threading.Tasks;
using Newtonsoft.Json;

namespace CelloSaaS.RestApiSDK
{
    public abstract class CelloHttpClient : IDisposable
    {
        private HttpClient _client;

        protected HttpClient Client { get { return _client; } }

        public CelloHttpClient(string baseAddress = "https://localhost/api", string username = "", string api_key = "")
        {
            _client = new HttpClient();
            _client.BaseAddress = new Uri(baseAddress);

            if (!string.IsNullOrEmpty(username) && !string.IsNullOrEmpty(api_key))
            {
                var encoding = Encoding.GetEncoding("iso-8859-1");
                var key = string.Format(CultureInfo.CurrentCulture, "{0}:{1}", username, api_key);
                var parameter = Convert.ToBase64String(encoding.GetBytes(key));
                _client.DefaultRequestHeaders.Authorization = new AuthenticationHeaderValue("Basic", parameter);
            }
            
            _client.DefaultRequestHeaders.Accept.Clear();
            AddAcceptHeader(new MediaTypeWithQualityHeaderValue("application/json"));
        }

        protected void AddAcceptHeader(MediaTypeWithQualityHeaderValue value)
        {
            _client.DefaultRequestHeaders.Accept.Add(value);
        }

        public void Dispose()
        {
            if (_client != null)
                _client.Dispose();
        }
    }
}
