﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Net.Http;

namespace CelloSaaS.RestApiSDK
{
    /// <summary>
    /// This client is used for invoking Notifications API endpoints.
    /// </summary>
    public class NotificationsClient : CelloHttpClient
    {
        public NotificationsClient(string baseAddress = "https://localhost/api/notifications/", string username = "", string api_key = "")
            : base(baseAddress, username, api_key)
        {
        }
        /// <summary>
        /// This method is used to invoke <c>'search_email_audits'</c> endpoint.
        /// </summary>
        /// <param name="condition">condition</param>
        /// <returns>search result</returns>
        public EmailAuditSearchResultDTO SearchEmailAudits(EmailAuditSearchConditionDTO condition)
        {
            var uri = "search_email_audits";
            
            var response = this.Client.PostAsJsonAsync(uri, condition).Result;

            if (response.IsSuccessStatusCode)
            {
                var result = response.Content.ReadAsAsync<EmailAuditSearchResultDTO>().Result;
                return result;
            }
            throw new Exception(response.Content.ReadAsStringAsync().Result);
        }

        /// <summary>
        /// This method is used to invoke <c>'send_email'</c> endpoint.
        /// </summary>
        /// <param name="data">required data to be send</param>
        public void SendEmail(EmailDTO data)
        {
            var uri = "send_email";

            var response = this.Client.PostAsJsonAsync(uri, data).Result;

            if (response.StatusCode == System.Net.HttpStatusCode.Accepted)
            {
                return;
            }            
            throw new Exception(response.Content.ReadAsStringAsync().Result);
        }
    }
}
