﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace CelloSaaS.RestApiSDK
{
    public enum BillCycleModeDTO { postpaid, prepaid }
    public class PricePlanLineItemDTO
    {
        public Guid Id { get; set; }
        public Guid PricePlanId { get; set; }
        public string Name { get; set; }
        public string Description { get; set; }
        public Guid PriceTableId { get; set; }
        public PriceTableDTO PriceTable { get; set; }
    }
    public class PriceSlabDTO
    {
        public Guid Id { get; set; }
        public Guid PriceTableId { get; set; }
        public double StartValue { get; set; }
        public double? EndValue { get; set; }
        public double Factor { get; set; }
    }
    public class BillStatisticsDTO
    {
        public Guid TenantId { get; set; }
        public int TotalBills { get; set; }
        public double TotalAmount { get; set; }
        public double TotalPaid { get; set; }
        public double TotalTax { get; set; }
        public double Overdue { get { return Math.Round(TotalAmount - TotalPaid, 2); } }
    }
    public class BillStatisticsSearchConditionDTO
    {
        public Guid[] TenantIds { get; set; }
        public bool OnlyOverdue { get; set; }
        public double? MinOverdueAmount { get; set; }
        public double? MaxOverdueAmount { get; set; }
        public double? MinTotalAmount { get; set; }
        public double? MaxTotalAmount { get; set; }
        public DateTime? FromDate { get; set; }
        public DateTime? ToDate { get; set; }
        public int TopTenants { get; set; }
    }
}
