﻿using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace CelloSaaS.RestApiSDK
{
    public class RoleDTO : BaseDTO
    {
        /// <summary>
        /// Gets or set unique Identifier of the Role.
        /// </summary>
        public string id { get; set; }

        /// <summary>
        /// Gets or set unique Identifier of the Tenant
        /// </summary>
        public Guid? tenant_id { get; set; }

        /// <summary>
        /// Gets or sets unique name of role.
        /// </summary>
        public string name { get; set; }

        /// <summary>
        /// Gets or sets description of the role.
        /// </summary>
        public string description { get; set; }

        /// <summary>
        /// Gets or sets the role is global or tenant based.
        /// </summary>
        public bool is_global { get; set; }
    }


    public enum ResourceTypeConstants
    {
        /// <summary>
        /// 
        /// </summary>
        UI = 0,

        /// <summary>
        /// 
        /// </summary>
        BL = 1,
    }
}
