﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace WebApiSDKUnitTest
{
    /// <summary>
    /// This class is responsible for handling the exception occuring during the testing.
    /// </summary>
    public class ExceptionHelper
    {
        public const string InvalidDataViewIDErrorMsg= "Invalid dataview id was  passed!";
        public const string InvaldiEntityIDErrorMsg = "Invalid entity id was  passed!";
        public const string InvalidUserIDErrorMsg = "Invalid user id was passed!";
        public const string InvalidUserNameErrorMsg = "Invalid user name was passed!";
        public const string InvalidUserIdentifierErrorMsg = "Invalid user identifier was passed!";
        public const string InvalidURIErrorMsg = "Invalid URI: The format of the URI could not be determined.";
        public const string InvalidFriendlyCodeErrorMsg = "Invalid friendly_code is passed!.";

        public const string ValidationErrorCode = @"""err_code"":""Validation""";
        public const string ArgumentNullErrorCode = @"""err_code"":""ArgumentNullException""";
        public const string ArgumentExceptionErrorCode = @"""err_code"":""ArgumentException""";
        
        public const string TenantExceptionErrorCode = @"""err_code"":""TenantException""";
        public const string TenantSettingsExceptionErrorCode= @"""err_code"":""TenantSettingsException""";
        public const string UserDetailExceptionErrorCode= @"""err_code"":""UserDetailException""";
        public const string RoleExceptionErrorCode = @"""err_code"":""RoleException""";
        public const string NullReferenceErrorCode = @"""err_code"":""NullReferenceException""";
        public const string LicenseExceptionErrorCode= @"""err_code"":""LicenseException""";

        public const string InvalidUserNameExceptionErrorCode= @"""err_code"":""InvalidUserNameException""";
        public const string UnauthorizedAccessExceptionErrorCode = @"""err_code"":""UnauthorizedAccessException""";
        public const string DuplicateTenantNameExceptionErrorCode= @"""err_code"":""DuplicateTenantNameException""";
        public const string DataExceptionErrorCode = @"""err_code"":""DataException""";
        public const string InvalidURLExceptionErrorCode= @"""err_code"":""InvalidURLException""";

        private const char Delimiter = ',';

        public string GetErrorCode(string errorMessage)
        {
            string ErrorCode = null;
            if(!string.IsNullOrEmpty(errorMessage))
            {
                string[] errorCode = errorMessage.Split(Delimiter).ToArray();
                ErrorCode= errorCode.First().Remove(0, 1);
            }
            return ErrorCode;
        }

    }
}
